<script setup lang="ts">
import type { GOAnnotation } from "~/utils/types/goannotation";
const { loggedIn } = useOidcAuth();
const props = defineProps<{
  annotation: Omit<GOAnnotation, "id">;
  dense?: boolean;
}>();

const dense = computed(() => props.dense || false);
const annotation = computed(() => props.annotation);

const linkEvidence = computed(() => {
  if (annotation.value.evidence) {
    return "http://geneontology.org/docs/guide-go-evidence-codes/";
  }
});

const pmid = computed(() => {
  return annotation.value.reference
    .split("|")
    .filter((r) => r.startsWith("PMID:"))[0]
    ?.split(":")[1];
});

const linkReference = computed(() => {
  if (pmid.value) {
    return `https://pubmed.ncbi.nlm.nih.gov/${pmid.value}`;
  }
});

const linkGeneOntologyTerm = computed(() => {
  if (annotation.value.term.id) {
    return `http://amigo.geneontology.org/amigo/term/${annotation.value.term.id}`;
  }
});

const statusColor = computed(() => {
  return annotation.value.status === "INTERNAL" ? "success" : "warning";
});

const adminAttributes = computed(() => {
  return [
    {
      header: "Gene",
      value: annotation.value.gene,
    },
    {
      header: "Lab",
      value: annotation.value.lab,
    },
    {
      header: "Date",
      value: annotation.value.date,
    },
  ];
});
</script>

<template>
  <div
    :class="dense ? 'mb-2 text-body-2' : 'mb-0 text-subtitle-1'"
    :style="{ 'line-height': dense ? '1rem' : '1.25rem' }"
  >
    <OutLink :to="linkGeneOntologyTerm">
      <span v-if="dense">
        {{ annotation.term.name }}
      </span>
      <span v-else>
        {{ annotation.term.id }} - {{ annotation.term.name }}
      </span>
    </OutLink>
    <template v-if="!dense">
      <v-chip
        v-if="annotation.evidence"
        class="mr-1 ml-1"
        link
        size="x-small"
        density="comfortable"
        :href="linkEvidence"
        target="_blank"
      >
        {{ annotation.evidence }}
        <v-icon size="x-small"> mdi-open-in-new </v-icon>
      </v-chip>
      <v-chip
        class="mr-1"
        link
        size="x-small"
        density="comfortable"
        :color="statusColor"
      >
        {{ annotation.status === "INTERNAL" ? "REVIEWED" : annotation.status }}
      </v-chip>
      <span v-if="annotation.quotation" class="text-body-2">
        <br />
        <v-icon size="x-small">mdi-chevron-double-right</v-icon>
        {{ annotation.quotation }}
        <v-icon size="x-small">mdi-chevron-double-left</v-icon>
      </span>
      <v-chip
        v-if="pmid"
        class="mr-1"
        link
        size="x-small"
        density="comfortable"
        :href="linkReference"
        target="_blank"
      >
        PMID:{{ pmid }}
        <v-icon size="x-small"> mdi-open-in-new </v-icon>
      </v-chip>

      <client-only>
        <div v-if="loggedIn" class="mt-2">
          <AttributeList :attributes="adminAttributes" vertical />
        </div>
      </client-only>
    </template>
  </div>
</template>
